/*///////////////////////////////////////////////////////////////////////////
	
	Trackbar.cpp
	
	(C) 2003 Radek Chalupa
	
///////////////////////////////////////////////////////////////////////////*/

#define WINVER 0x0500
#define _WIN32_WINNT 0x0500

#include <windows.h>
#include <tchar.h>
#include <commctrl.h>
#include <stdio.h>
#include <windows.h>

#include "resource.h"

#pragma comment (lib, "comctl32.lib")

/////////////////////////////////////////////////////////////////////////////

#define DOLNI_MEZ 5
#define HORNI_MEZ 25

BOOL g_OK = TRUE;

void NastavZnacky(HWND hWnd)
{
	SendDlgItemMessage(hWnd, IDC_TRACKBAR, TBM_SETTIC, 0, (WPARAM)DOLNI_MEZ);
	SendDlgItemMessage(hWnd, IDC_TRACKBAR, TBM_SETTIC, 0, (WPARAM)HORNI_MEZ);
}

void NastavRozsah(HWND hWnd)
{
	SendDlgItemMessage(hWnd, IDC_TRACKBAR, TBM_SETRANGE,
		TRUE, MAKELONG(0,30));
	SendDlgItemMessage(hWnd, IDC_TRACKBAR, TBM_SETPOS,
		TRUE, 10);
}

/////////////////////////////////////////////////////////////////////
// Obsluha zprvy WM_HSCROLL

void ZmenaPolohy(HWND hWnd)
{
	LRESULT pozice =
		SendDlgItemMessage(hWnd, IDC_TRACKBAR, TBM_GETPOS, 0, 0);
	SetDlgItemInt(hWnd, IDC_POLOHA, pozice, FALSE);
	if ( pozice < DOLNI_MEZ || pozice > HORNI_MEZ )
	{
		if ( g_OK )
		{
			g_OK = FALSE;
			SendDlgItemMessage(hWnd, IDC_IKONA, STM_SETIMAGE,
				IMAGE_ICON, (LPARAM)LoadIcon(NULL, IDI_ERROR));
		}
		MessageBeep(MB_ICONERROR);
	}
	else
	{
		if ( !g_OK )
		{
			g_OK = TRUE;
			SendDlgItemMessage(hWnd, IDC_IKONA, STM_SETIMAGE, IMAGE_ICON,
				(LPARAM)LoadIcon(GetModuleHandle(0), MAKEINTRESOURCE(IDI_HLAVNI)));
		}
	}
}

/////////////////////////////////////////////////////////////////////////////
// Procedura dialogu

INT_PTR CALLBACK DialogProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch ( uMsg )
	{
		case WM_COMMAND:
			switch ( LOWORD(wParam) )
			{
				case IDOK:
					EndDialog(hWnd, IDOK);
					break;
				case IDCANCEL:
					EndDialog(hWnd, IDCANCEL);
					break;
			}
			break;
			
		case WM_INITDIALOG:
			NastavRozsah(hWnd);
			NastavZnacky(hWnd);
			ZmenaPolohy(hWnd);
			break;
		case WM_HSCROLL:
			ZmenaPolohy(hWnd);
			break;
	}
	return FALSE;
}

/////////////////////////////////////////////////////////////////////////////
// Hlavn funkce programu pro Windows

int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow)
{
	INITCOMMONCONTROLSEX icc;
	icc.dwSize = sizeof(INITCOMMONCONTROLSEX);
	icc.dwICC = ICC_WIN95_CLASSES  | ICC_USEREX_CLASSES;
	if ( !InitCommonControlsEx(&icc) )
	  return -1;
	DialogBox(hInstance, MAKEINTRESOURCE(IDD_HLAVNI), NULL, DialogProc);
	return 0;
}
